| package |
package := Package name: 'US Treemap - Layout Abstract'.
package paxVersion: 0;
	basicComment: ''.

package basicPackageVersion: '0.015'.


package classNames
	add: #AbstractTreemapLayoutStrategy;
	yourself.

package methodNames
	add: #Collection -> #sum;
	yourself.

package binaryGlobalNames: (Set new
	yourself).

package globalAliases: (Set new
	yourself).

package allResourceNames: (Set new
	yourself).

package setPrerequisites: (IdentitySet new
	add: '..\..\..\Object Arts\Dolphin\Base\Dolphin';
	yourself).

package!

"Class Definitions"!

Object subclass: #AbstractTreemapLayoutStrategy
	instanceVariableNames: 'renderStrategy'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!

"Global Aliases"!


"Loose Methods"!

!Collection methodsFor!

sum
	"Sumarizes all items' size"
	^self inject: 0 into: [:sum :each | sum + each size]! !
!Collection categoriesFor: #sum!operations!public! !

"End of package definition"!

"Source Globals"!

"Classes"!

AbstractTreemapLayoutStrategy guid: (GUID fromString: '{CC8B4888-70E3-44D2-B20E-F83BE7AD2F03}')!
AbstractTreemapLayoutStrategy comment: 'AbstractTreeMapLayoutStrategy implements the <Treemap Layout Strategy> protocol used by TreemapRenderer.

Subclasses shoul override #layout:using and class>>#description.

See SliceAndDiceLayoutStrategy for a simple implementation. Take special care for layouting only child nodes with extent and updating the renderState.

Instance Variables:
	renderStrategy		<kindOf AbstractTreemapRenderStrategy>

'!
!AbstractTreemapLayoutStrategy categoriesForClass!Unclassified! !
!AbstractTreemapLayoutStrategy methodsFor!

layout: aTreemapModel in: aRectangle using: aTreemapRenderState 
	| node |
	node := (aTreemapModel rootNode)
				setLayoutRectangle: aRectangle;
				yourself.
	self layout: node using: aTreemapRenderState !

layout: aTreemapNode using: aTreemapRenderState 
	"Layout the node (including child nodes) in a Rectangle specified by aNode>>layoutRectangle.
	Create new renderSettings per child node using #update:in:, #update:horizontalIn: or #update:verticalIn:"

	^self subclassResponsibility!

setRenderStrategy: aTreeMapRenderStrategy
	renderStrategy := aTreeMapRenderStrategy! !
!AbstractTreemapLayoutStrategy categoriesFor: #layout:in:using:!public! !
!AbstractTreemapLayoutStrategy categoriesFor: #layout:using:!private! !
!AbstractTreemapLayoutStrategy categoriesFor: #setRenderStrategy:!private! !

AbstractTreemapLayoutStrategy methodProtocol: #'Treemap Layout Strategy' attributes: #(#readOnly) selectors: #(#layout:in:using: #layout:using: #setRenderStrategy:)!

!AbstractTreemapLayoutStrategy class methodsFor!

description
^self class displayString! !
!AbstractTreemapLayoutStrategy class categoriesFor: #description!public! !

"Binary Globals"!

"Resources"!

