| package |
package := Package name: 'US Treemap - Render Circle'.
package paxVersion: 0;
	basicComment: ''.

package basicPackageVersion: '0.014'.


package classNames
	add: #CircleRenderState;
	add: #CircleRenderStrategy;
	yourself.

package binaryGlobalNames: (Set new
	yourself).

package globalAliases: (Set new
	yourself).

package allResourceNames: (Set new
	yourself).

package setPrerequisites: (IdentitySet new
	add: '..\..\..\Object Arts\Dolphin\MVP\Base\Dolphin MVP Base';
	add: 'US Treemap - Render Abstract';
	yourself).

package!

"Class Definitions"!

LightningRenderStrategy subclass: #CircleRenderStrategy
	instanceVariableNames: 'brushCache'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
TreeMapRenderState subclass: #CircleRenderState
	instanceVariableNames: 'rectangle vector'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!

"Global Aliases"!


"Loose Methods"!

"End of package definition"!

"Source Globals"!

"Classes"!

CircleRenderStrategy guid: (GUID fromString: '{5733B7EA-55B3-4EB1-A8B4-F2C9A6DB56E9}')!
CircleRenderStrategy comment: ''!
!CircleRenderStrategy categoriesForClass!Treemap-Render! !
!CircleRenderStrategy methodsFor!

initialize
	brushCache := LightningColorCache fillBlock: 
					[:basecolor | 
					(0 to: self directLightIntensity) 
						collect: [:index | Brush color: (basecolor darkenBy: 255 - index - self ambientLightIntensity)]]!

initialRenderState
	^CircleRenderState new!

render: node using: renderSettings 
	| nodeRectangle center radius r brushes vector ellipsenodeRectangle |
	nodeRectangle := node layoutRectangle.
	radius := ((nodeRectangle center - nodeRectangle topLeft) r * 1.2) truncated.
	brushes := brushCache at: (renderer nodeColor: node object).
	canvas
		selectClipRegion: (Region rectangle: nodeRectangle truncated);
		brush: (brushes first);
		fillRectangle: nodeRectangle truncated;
		pen: Pen null.
	vector := renderSettings vector / self directLightIntensity.
	center := nodeRectangle center.
	0 to: self directLightIntensity
		by: self renderStep
		do: 
			[:index | 
			r := radius * (1 - (index / self directLightIntensity)).
			ellipsenodeRectangle := ((center - r corner: center + r) moveBy: vector * index) 
						truncated.
			canvas
				brush: (brushes at: index + 1);
				ellipse: ellipsenodeRectangle]! !
!CircleRenderStrategy categoriesFor: #initialize!public! !
!CircleRenderStrategy categoriesFor: #initialRenderState!public! !
!CircleRenderStrategy categoriesFor: #render:using:!public! !

!CircleRenderStrategy class methodsFor!

description
	^'Circle'! !
!CircleRenderStrategy class categoriesFor: #description!public! !

CircleRenderState guid: (GUID fromString: '{C20B81B7-6778-4512-88A8-9D8F61300857}')!
CircleRenderState comment: ''!
!CircleRenderState categoriesForClass!Unclassified! !
!CircleRenderState methodsFor!

setRectangle: aRectangle vector: aVector 
	rectangle := aRectangle.
	vector := aVector.!

setRootRectangle: aRectangle 
	rectangle := aRectangle!

update: aNode horizontalIn: aRectangle 
^self update: aNode in: aRectangle !

update: aNode in: aRectangle 
	((aNode hasParent ) and: [aNode hasExtent])
		ifTrue: 
			[| newVector |
			newVector := (rectangle center - aRectangle center) / (rectangle area / aRectangle area) + self vector.
			^self class rectangle: aRectangle vector: newVector]
		ifFalse: [^self class rectangle: aRectangle vector: 0 @ 0]!

update: aNode verticalIn: aRectangle 
	^self update: aNode in: aRectangle !

vector
^vector! !
!CircleRenderState categoriesFor: #setRectangle:vector:!private! !
!CircleRenderState categoriesFor: #setRootRectangle:!public! !
!CircleRenderState categoriesFor: #update:horizontalIn:!public! !
!CircleRenderState categoriesFor: #update:in:!public! !
!CircleRenderState categoriesFor: #update:verticalIn:!public! !
!CircleRenderState categoriesFor: #vector!public! !

!CircleRenderState class methodsFor!

new
	^self rectangle: (0 @ 0 extent: 0 @ 0) vector: 0 @ 0!

rectangle: aRectangle vector: aVector 
	^self basicNew setRectangle: aRectangle vector: aVector; yourself! !
!CircleRenderState class categoriesFor: #new!public! !
!CircleRenderState class categoriesFor: #rectangle:vector:!public! !

"Binary Globals"!

"Resources"!

