| package |
package := Package name: 'US Treemap - Render Cushion DirectToMemory'.
package paxVersion: 0;
	basicComment: ''.

package basicPackageVersion: '0.013'.


package classNames
	add: #DirectCushionRenderStrategy;
	yourself.

package binaryGlobalNames: (Set new
	yourself).

package globalAliases: (Set new
	yourself).

package allResourceNames: (Set new
	yourself).

package setPrerequisites: (IdentitySet new
	add: '..\..\..\Object Arts\Dolphin\MVP\Base\Dolphin MVP Base';
	add: 'US Treemap - Render Cushion Abstract';
	yourself).

package!

"Class Definitions"!

AbstractCushionRenderStrategy subclass: #DirectCushionRenderStrategy
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!

"Global Aliases"!


"Loose Methods"!

"End of package definition"!

"Source Globals"!

"Classes"!

DirectCushionRenderStrategy guid: (GUID fromString: '{C0787843-E04D-48FF-B617-EFA736E010F4}')!
DirectCushionRenderStrategy comment: ''!
!DirectCushionRenderStrategy categoriesForClass!Treemap-Render! !
!DirectCushionRenderStrategy methodsFor!

createColorTableFor: node 
	"| shadedBrushes basecolor |
	basecolor := renderer nodeColor: node object.
	shadedBrushes := Array new: 256.
	1 to: 256
		do: 
			[:shade | 
			shadedBrushes at: shade
				put: (basecolor darkenBy: 255 
								- (self ambientLightIntensity + (self directLightIntensity * ((shade - 1) / 255)))) 
						asDWORD].
	^shadedBrushes"
	| basecolor |
	basecolor := renderer nodeColor: node object.

	^(1 to: 256) collect: [ :each |(basecolor darkenBy: 255 
								- (self ambientLightIntensity + (self directLightIntensity * ((each - 1) / 255)))) 
						asDWORD].
!

render: node using: aRenderState 
	| shadedBrushes surface |
	shadedBrushes := self createColorTableFor: node.
	surface := aRenderState surface.
	canvas
		selectClipRegion: nil;
		fillRectangle: node layoutRectangle truncated brush: (Brush color: Color white).
	node layoutRectangle top truncated to: node layoutRectangle bottom truncated - 1
		do: 
			[:iy | 
			| pixelAddress |
			pixelAddress := iy * bitmap getInfo bmWidthBytes 
						+ (node layoutRectangle left truncated * 4).
			node layoutRectangle left truncated to: node layoutRectangle right truncated
				do: 
					[:ix | 
					| lightIntensity |
					lightIntensity := surface lightIntensityAt: ix @ iy.
					bitmap imageBits dwordAtOffset: pixelAddress
						put: (shadedBrushes at: (0 max: (lightIntensity * 255) truncated) + 1).
					pixelAddress := pixelAddress + 4]]! !
!DirectCushionRenderStrategy categoriesFor: #createColorTableFor:!public! !
!DirectCushionRenderStrategy categoriesFor: #render:using:!public! !

!DirectCushionRenderStrategy class methodsFor!

description
	^'Cushion - direct memory access'! !
!DirectCushionRenderStrategy class categoriesFor: #description!public! !

"Binary Globals"!

"Resources"!

