| package |
package := Package name: 'US Treemap - Render Cushion Optimized'.
package paxVersion: 0;
	basicComment: ''.

package basicPackageVersion: '0.013'.


package classNames
	add: #OptimizedCushionRenderStrategy;
	yourself.

package binaryGlobalNames: (Set new
	yourself).

package globalAliases: (Set new
	yourself).

package allResourceNames: (Set new
	yourself).

package setPrerequisites: (IdentitySet new
	add: '..\..\..\Object Arts\Dolphin\MVP\Base\Dolphin MVP Base';
	add: 'US Treemap - Render Abstract';
	add: 'US Treemap - Render Cushion Abstract';
	yourself).

package!

"Class Definitions"!

AbstractCushionRenderStrategy subclass: #OptimizedCushionRenderStrategy
	instanceVariableNames: 'brushCache'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!

"Global Aliases"!


"Loose Methods"!

"End of package definition"!

"Source Globals"!

"Classes"!

OptimizedCushionRenderStrategy guid: (GUID fromString: '{B73FF5B2-C498-4819-97D0-F1BD1057AB11}')!
OptimizedCushionRenderStrategy comment: ''!
!OptimizedCushionRenderStrategy categoriesForClass!Treemap-Render! !
!OptimizedCushionRenderStrategy methodsFor!

initialize
	brushCache := LightningColorCache fillBlock: 
					[:basecolor | 
					(0 to: self directLightIntensity) 
						collect: [:index | Brush color: (basecolor darkenBy: 255 - index - self ambientLightIntensity)]]!

render: node using: aRenderState 
	| surface brushes |
	brushes := brushCache at: (renderer nodeColor: node object).
	surface := aRenderState surface.
	canvas
		selectClipRegion: (Region rectangle: node layoutRectangle truncated);
		pen: Pen null.
	node layoutRectangle top truncated to: node layoutRectangle bottom truncated
		by: self renderStep
		do: 
			[:iy | 
			node layoutRectangle left truncated to: node layoutRectangle right truncated
				by: self renderStep
				do: 
					[:ix | 
					| lightIntensity |
					lightIntensity := (0 max: self directLightIntensity * (surface lightIntensityAt: ix @ iy)) 
								truncated.
					canvas fillRectangle: (ix @ iy extent: self renderStep@self renderStep)
						brush: (brushes at: lightIntensity + 1)]]! !
!OptimizedCushionRenderStrategy categoriesFor: #initialize!public! !
!OptimizedCushionRenderStrategy categoriesFor: #render:using:!public! !

!OptimizedCushionRenderStrategy class methodsFor!

description
	
	^'Cushion - GDI optimized'! !
!OptimizedCushionRenderStrategy class categoriesFor: #description!public! !

"Binary Globals"!

"Resources"!

