| package |
package := Package name: 'US Treemap - Bonsai'.
package paxVersion: 0;
	basicComment: 'TreePresenter addView: TreeMapView asResource: ''Treemap view''.
TreePresenter addView: AsynchronousTreeMapView asResource: ''Treemap view asynchronous'' .


model :=  ClassHierarchyModel withAllClasses.

my := Bag with: ''abc123''.

stream := ReadWriteStream on: Array new.
stream nextPutAll:  #( ''1'' ''23'' ''456'' ''7890'' ''11121314'' ''151617181920'' ''1''); nextPut: my; nextPutAll: #(''23'' ''456'' ''7890'' ''11121314'' ''151617181920'' ''1'' ''23'' ''456'' ''7890'' ''11121314'' ''151617181920'').
array := stream contents.

model := TreeModel withRoots: array.

TreePresenter showOn: model

presenter := TreePresenter show: ''treemap'' on: model.
presenter view renderer inspect.

presenter :=  TreePresenter show:  ''Treemap view asynchronous''  on: model.
presenter view renderer inspect.

presenter selection: my.
presenter selection: nil.
presenter selection

[ 10 timesRepeat: [
(Delay forMilliseconds: 100) wait.
my add: ''abc123''.
model refresh: my.

]] fork

getImageBlock

BonsaiShell show


truncated


'.

package basicPackageVersion: '0.033'.

package imageStripperBytes: (ByteArray fromBase64String: 'IVNUQiAxIEYPDQAEAAAASW1hZ2VTdHJpcHBlcgAAAAAAAAAAUgAAAAYAAABCb25zYWlSAAAAGAAA
AFVkbyBTY2huZWlkZXJcQm9uc2FpLmV4ZZoAAAAAAAAAUgAAAAYAAABCb25zYWlSAAAAFAAAAEJv
bnNhaVNlc3Npb25NYW5hZ2Vy778lAAAAAAAGAw8AVmVyc2lvblJlc291cmNlAAAAAAYBEABWU19G
SVhFREZJTEVJTkZPAAAAAHIAAAA0AAAAvQTv/gAAAQAAAAEAAQAAAAAAAQABAAAAPwAAAAAAAAAE
AAAAAgAAAAAAAAAAAAAAAAAAAOoAAAAAAAAA8AAAAGIAAAACAAAAUgAAAAgAAAAwNDA5MDRiMOoA
AAAAAAAA8AAAAGIAAAAYAAAAUgAAAA4AAABQcm9kdWN0VmVyc2lvblIAAAAKAAAAMSwgMCwgMCwg
MVIAAAALAAAAQ29tcGFueU5hbWVSAAAAAAAAAFIAAAAMAAAAUHJpdmF0ZUJ1aWxkUgAAAAAAAABS
AAAADAAAAFNwZWNpYWxCdWlsZFIAAAAAAAAAUgAAAA8AAABGaWxlRGVzY3JpcHRpb25SAAAAGwAA
AERvbHBoaW4gWFAgVG9HbyBBcHBsaWNhdGlvblIAAAAPAAAATGVnYWxUcmFkZW1hcmtzUgAAADEA
AABEb2xwaGluIGlzIGEgdHJhZGVtYXJrIG9mIENHSSBHcm91cCAoRXVyb3BlKSBMdGQuUgAAAAwA
AABJbnRlcm5hbE5hbWVSAAAAAAAAAFIAAAAQAAAAT3JpZ2luYWxGaWxlbmFtZVIAAAAKAAAAQm9u
c2FpLmV4ZVIAAAAOAAAATGVnYWxDb3B5cmlnaHRSAAAAKwAAAFBvcnRpb25zIENvcHlyaWdodCCp
IE9iamVjdCBBcnRzIDE5OTctMjAwMy5SAAAACAAAAENvbW1lbnRzUgAAABwAAABQb3dlcmVkIGJ5
IERvbHBoaW4gU21hbGx0YWxrUgAAAAsAAABGaWxlVmVyc2lvblIAAAAKAAAAMSwgMCwgMCwgMVIA
AAALAAAAUHJvZHVjdE5hbWVSAAAAHQAAAEEgRG9scGhpbiBYUCBUb0dvIEFwcGxpY2F0aW9uygAA
AAAAAADQAAAAYgAAAAEAAAAGAgoARFdPUkRBcnJheQAAAAByAAAABAAAAAkEsAQDAAAAAAAAAAAA
AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA=').

package classNames
	add: #BonsaiFile;
	add: #BonsaiFolder;
	add: #BonsaiPath;
	add: #BonsaiSessionManager;
	add: #BonsaiShell;
	yourself.

package methodNames
	add: #WIN32_FIND_DATA -> #isDotFile;
	yourself.

package binaryGlobalNames: (Set new
	yourself).

package globalAliases: (Set new
	yourself).

package allResourceNames: (Set new
	add: #BonsaiShell -> 'Default view';
	yourself).

package setPrerequisites: (IdentitySet new
	add: '..\..\..\Object Arts\Dolphin\Base\Dolphin';
	add: '..\..\..\Object Arts\Dolphin\MVP\Views\Common Controls\Dolphin Common Controls';
	add: '..\..\..\Object Arts\Dolphin\MVP\Views\MoenTree\Dolphin MoenTree View';
	add: '..\..\..\Object Arts\Dolphin\MVP\Base\Dolphin MVP Base';
	add: '..\..\..\Object Arts\Dolphin\MVP\Models\Tree\Dolphin Tree Models';
	add: '..\..\..\Object Arts\Dolphin\MVP\Type Converters\Dolphin Type Converters';
	add: '..\..\..\Object Arts\Dolphin\Lagoon\Lagoon Image Stripper';
	add: '..\US Treemap - Base';
	add: '..\Layout\US Treemap - Layout Ordered';
	add: '..\Layout\US Treemap - Layout Slice and Dice';
	add: '..\Layout\US Treemap - Layout Squarified';
	add: '..\Render\US Treemap - Render Circle';
	add: '..\Render\US Treemap - Render Cushion Abstract';
	add: '..\Render\US Treemap - Render Cushion DirectToMemory';
	add: '..\Render\US Treemap - Render Cushion External';
	add: '..\Render\US Treemap - Render Cushion Optimized';
	add: '..\Render\US Treemap - Render Flat';
	add: '..\US Treemap - View';
	add: '..\..\..\Object Arts\Dolphin\ActiveX\Shell\Windows Shell';
	yourself).

package!

"Class Definitions"!

Object subclass: #BonsaiPath
	instanceVariableNames: 'path children parent'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
BonsaiPath subclass: #BonsaiFile
	instanceVariableNames: 'size'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
BonsaiPath subclass: #BonsaiFolder
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
Shell subclass: #BonsaiShell
	instanceVariableNames: 'pathPresenter renderStrategyPresenter layoutStrategyPresenter treemapPresenter treePresenter moenTreePresenter'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
RuntimeSessionManager subclass: #BonsaiSessionManager
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!

"Global Aliases"!


"Loose Methods"!

!WIN32_FIND_DATA methodsFor!

isDotFile
	^#('.' '..') includes: self fileName! !
!WIN32_FIND_DATA categoriesFor: #isDotFile!public!testing! !

"End of package definition"!

"Source Globals"!

"Classes"!

BonsaiPath guid: (GUID fromString: '{11AA1B6D-9D26-43AE-9919-B5E30BB2C47F}')!
BonsaiPath comment: ''!
!BonsaiPath categoriesForClass!Unclassified! !
!BonsaiPath methodsFor!

<= aBonsaiPath 
		self subclassResponsibility!

children
	children isNil ifTrue: [children := self getChildren asSortedCollection].
	^children!

compareWithFile: aBonsaiPath 
	self subclassResponsibility!

compareWithFolder: aBonsaiPath
self subclassResponsibility!

getChildren
self subclassResponsibility!

isDirectory
	self subclassResponsibility!

parent^parent!

path
	^path!

pathComponent
^self path!

printOn: aStream 
	super printOn: aStream.
	aStream nextPutAll: ' (' , self path , ')'!

setParent: anObject
"Private"
parent := anObject!

setPath: aString 
	path := aString!

size
	^0! !
!BonsaiPath categoriesFor: #<=!public! !
!BonsaiPath categoriesFor: #children!public! !
!BonsaiPath categoriesFor: #compareWithFile:!private! !
!BonsaiPath categoriesFor: #compareWithFolder:!private! !
!BonsaiPath categoriesFor: #getChildren!private! !
!BonsaiPath categoriesFor: #isDirectory!public! !
!BonsaiPath categoriesFor: #parent!private! !
!BonsaiPath categoriesFor: #path!accessing!public! !
!BonsaiPath categoriesFor: #pathComponent!public! !
!BonsaiPath categoriesFor: #printOn:!public! !
!BonsaiPath categoriesFor: #setParent:!private! !
!BonsaiPath categoriesFor: #setPath:!private! !
!BonsaiPath categoriesFor: #size!accessing!public! !

!BonsaiPath class methodsFor!

fromWIN32_FIND_DATA: aWIN32_FIND_DATA parent: aBonsaiPath 
	self subclassResponsibility! !
!BonsaiPath class categoriesFor: #fromWIN32_FIND_DATA:parent:!public! !

BonsaiFile guid: (GUID fromString: '{D8C70044-A077-4126-AC0A-09FCFB7C9A6D}')!
BonsaiFile comment: ''!
!BonsaiFile categoriesForClass!Unclassified! !
!BonsaiFile methodsFor!

<= aBonsaiPath 
	^aBonsaiPath compareWithFile: self!

compareWithFile: aBonsaiPath 
	^ aBonsaiPath path<=  self path!

compareWithFolder: aBonsaiPath 
	^true!

getChildren
	^#()!

isDirectory
	^false!

pathComponent
	^File titleOf: self  path!

setSize: anObject 
	size := anObject!

size
	^size! !
!BonsaiFile categoriesFor: #<=!public! !
!BonsaiFile categoriesFor: #compareWithFile:!private! !
!BonsaiFile categoriesFor: #compareWithFolder:!private! !
!BonsaiFile categoriesFor: #getChildren!private! !
!BonsaiFile categoriesFor: #isDirectory!public! !
!BonsaiFile categoriesFor: #pathComponent!public! !
!BonsaiFile categoriesFor: #setSize:!accessing!private! !
!BonsaiFile categoriesFor: #size!accessing!private! !

!BonsaiFile class methodsFor!

fromWIN32_FIND_DATA: aWIN32_FIND_DATA parent: anBonsaiFolder 
	^(self new)
		setPath: aWIN32_FIND_DATA path;
		setSize: aWIN32_FIND_DATA fileSize;
		setParent: anBonsaiFolder;
		yourself!

icon
	^File icon! !
!BonsaiFile class categoriesFor: #fromWIN32_FIND_DATA:parent:!public! !
!BonsaiFile class categoriesFor: #icon!public! !

BonsaiFolder guid: (GUID fromString: '{B2694A66-00CC-4106-8801-6392ADBEF1E2}')!
BonsaiFolder comment: ''!
!BonsaiFolder categoriesForClass!Unclassified! !
!BonsaiFolder methodsFor!

<= aBonsaiPath 
	^aBonsaiPath compareWithFolder: self!

compareWithFile: aBonsaiPath 
	^false!

compareWithFolder: aBonsaiPath 
	^aBonsaiPath path  <= self path!

getChildren
	children := OrderedCollection new.
	File 
		for: '*.*'
		in: self path
		do: 
			[:each | 
			each isDirectory 
				ifTrue: 
					[each isDotFile 
						ifFalse: 
							[children add: ((BonsaiFolder fromWIN32_FIND_DATA: each parent: self)
										setParent: self;
										yourself)]]
				ifFalse: [children add: (BonsaiFile fromWIN32_FIND_DATA: each parent: self)]].
	^children !

isDirectory
	^true!

pathComponent
	^(self  path subStrings: '\') last displayString! !
!BonsaiFolder categoriesFor: #<=!public! !
!BonsaiFolder categoriesFor: #compareWithFile:!private! !
!BonsaiFolder categoriesFor: #compareWithFolder:!private! !
!BonsaiFolder categoriesFor: #getChildren!private! !
!BonsaiFolder categoriesFor: #isDirectory!public! !
!BonsaiFolder categoriesFor: #pathComponent!public! !

!BonsaiFolder class methodsFor!

fromString: aString 
	^(self new)
		setPath: aString;
		yourself!

fromWIN32_FIND_DATA: aWIN32_FIND_DATA parent: anBonsaiFolder 
	^(self new)
		setPath: aWIN32_FIND_DATA path , '\';
		setParent: anBonsaiFolder;
		yourself!

icon
	^Folder icon! !
!BonsaiFolder class categoriesFor: #fromString:!public! !
!BonsaiFolder class categoriesFor: #fromWIN32_FIND_DATA:parent:!public! !
!BonsaiFolder class categoriesFor: #icon!public! !

BonsaiShell guid: (GUID fromString: '{C01B730C-CECF-4E29-B30E-370041C2BD53}')!
BonsaiShell comment: ''!
!BonsaiShell categoriesForClass!Unclassified! !
!BonsaiShell methodsFor!

availableLayoutStrategies 
^##(TreeMapRenderer availableLayoutStrategies )!

availableRenderStrategies
	^##(TreeMapRenderer availableRenderStrategies)!

basicCaption 
^'Bonsai - '!

browseFolder
 |folder|
	folder := BrowseFolderDialog showModalOn: pathPresenter value.
	folder notNil ifTrue: [ self updateFolder: folder]!

createComponents
	super createComponents.
	pathPresenter := self add: TextPresenter new name: 'path'.
	layoutStrategyPresenter := self add: ChoicePresenter new name: 'layoutStrategy'.
	renderStrategyPresenter := self add: ChoicePresenter new name: 'renderStrategy'.
	treemapPresenter := self add: TreePresenter new name: 'treemap'.
	treePresenter := self add: TreePresenter new name: 'tree'.
moenTreePresenter := self add: TreePresenter new name: 'moentree'!

createSchematicWiring
	super createSchematicWiring.
	layoutStrategyPresenter 
		when: #selectionChanged
		send: #updateLayoutStrategy
		to: self.
	renderStrategyPresenter 
		when: #selectionChanged
		send: #updateRenderStrategy
		to: self.
	treemapPresenter 
		when: #selectionChanged
		send: #treemapSelectionChanged
		to: self.
	treePresenter 
		when: #selectionChanged
		send: #treeSelectionChanged
		to: self.
	moenTreePresenter 
		when: #selectionChanged
		send: #moenTreeSelectionChanged
		to: self.
	pathPresenter 
		when: #valueChanged
		send: #pathChanged
		to: self!

model: aModel 
	| treeModel |
	super model: (BonsaiFolder fromString: aModel).
	self updateCaption.
	treeModel := self treeModel.
	treePresenter model: treeModel.
	moenTreePresenter model: treeModel.
	treemapPresenter model: treeModel.
	layoutStrategyPresenter
		choices: (self availableLayoutStrategies 
					asSortedCollection: [:x :y | x description <= y description]);
		value: self availableLayoutStrategies first.
	renderStrategyPresenter
		choices: (self availableRenderStrategies 
					asSortedCollection: [:x :y | x description <= y description]);
		value: self availableRenderStrategies first.
	pathPresenter value: self model path!

moenTreeSelectionChanged
	treePresenter selection: moenTreePresenter selection.
treemapPresenter selection: moenTreePresenter selection.
!

onViewClosed
	super onViewClosed.
	SessionManager current isRuntime ifTrue: [SessionManager current exit]!

onViewOpened
	self updateLayoutStrategy; updateRenderStrategy.^super onViewOpened!

pathChanged
self updateFolder: pathPresenter value!

treemapSelectionChanged
	treePresenter selection: treemapPresenter selection.
	moenTreePresenter selection: treemapPresenter selection.
!

treeModel
^ VirtualTreeModel withRoots: (Array with: self model).
!

treeSelectionChanged
	treemapPresenter selection: treePresenter selection.
moenTreePresenter selection: treePresenter selection.!

updateCaption
	self caption: self basicCaption , self model path!

updateFolder: aString 
	((File exists: aString) and: [File isDirectory: aString]) 
		ifTrue: [self model: ( aString )]
		ifFalse: [MessageBox warning: '''' , aString , ''' does not exist or is no directory']!

updateLayoutStrategy
	treemapPresenter view renderer layoutStrategy: layoutStrategyPresenter value new!

updateRenderStrategy
		treemapPresenter view renderer renderStrategy: renderStrategyPresenter value new! !
!BonsaiShell categoriesFor: #availableLayoutStrategies!private! !
!BonsaiShell categoriesFor: #availableRenderStrategies!private! !
!BonsaiShell categoriesFor: #basicCaption!private! !
!BonsaiShell categoriesFor: #browseFolder!public! !
!BonsaiShell categoriesFor: #createComponents!public! !
!BonsaiShell categoriesFor: #createSchematicWiring!public! !
!BonsaiShell categoriesFor: #model:!public! !
!BonsaiShell categoriesFor: #moenTreeSelectionChanged!public! !
!BonsaiShell categoriesFor: #onViewClosed!public! !
!BonsaiShell categoriesFor: #onViewOpened!public! !
!BonsaiShell categoriesFor: #pathChanged!public! !
!BonsaiShell categoriesFor: #treemapSelectionChanged!public! !
!BonsaiShell categoriesFor: #treeModel!public! !
!BonsaiShell categoriesFor: #treeSelectionChanged!public! !
!BonsaiShell categoriesFor: #updateCaption!private! !
!BonsaiShell categoriesFor: #updateFolder:!public! !
!BonsaiShell categoriesFor: #updateLayoutStrategy!public! !
!BonsaiShell categoriesFor: #updateRenderStrategy!public! !

!BonsaiShell class methodsFor!

defaultModel
	^SessionManager current imageBase!

referencedClasses
"stream := ReadWriteStream on: String new.
TreeMapRenderer availableLayoutStrategies , TreeMapRenderer availableRenderStrategies 
	do: 
		[:each | 
		stream
			nextPutAll: each displayString;
			nextPut: $.;
			cr].
stream contents
"

	OrderedSquarifiedTreeMapStrategy.
	SliceAndDiceLayoutStrategy.
	PivotByBiggestStrategy.
	PivotByMiddleStrategy.
	PivotBySplitSizeStrategy.
	SortedSquarifiedTreeMapStrategy.
	FlatRenderStrategy.
	CircleRenderStrategy.
	DirectCushionRenderStrategy.
	ExternalCushionRenderStrategy.
	OptimizedCushionRenderStrategy.
	VanillaCushionRenderStrategy! !
!BonsaiShell class categoriesFor: #defaultModel!public! !
!BonsaiShell class categoriesFor: #referencedClasses!public! !

BonsaiSessionManager guid: (GUID fromString: '{8D850ACB-A8BA-4610-BF9C-8543DCE5E6B2}')!
BonsaiSessionManager comment: ''!
!BonsaiSessionManager categoriesForClass!Unclassified! !
!BonsaiSessionManager methodsFor!

main
	self mainShellClass show! !
!BonsaiSessionManager categoriesFor: #main!public! !

!BonsaiSessionManager class methodsFor!

mainShellClass
	"Answer the class of the application's main window (a <Shell> presenter)."

	^BonsaiShell! !
!BonsaiSessionManager class categoriesFor: #mainShellClass!constants!public! !

"Binary Globals"!

"Resources"!

(ResourceIdentifier class: BonsaiShell name: 'Default view') assign: (Object fromBinaryStoreBytes:
(ByteArray fromBase64String: 'IVNUQiAxIEYCDAABAAAAVmlld1Jlc291cmNlAAAAAA4BJABTVEJSZXNvdXJjZVNUQkJ5dGVBcnJh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'))!

