| package |
package := Package name: 'US Treemap - Space Breakdown'.
package paxVersion: 0;
	basicComment: ''.

package basicPackageVersion: '0.003'.


package classNames
	add: #TreemapReferenceBreakdown;
	add: #TreemapSpaceBreakdown;
	yourself.

package binaryGlobalNames: (Set new
	yourself).

package globalAliases: (Set new
	yourself).

package allResourceNames: (Set new
	add: #TreemapReferenceBreakdown -> 'Default view';
	add: #TreemapSpaceBreakdown -> 'Default view';
	add: #TreemapSpaceBreakdown -> 'Read-only view';
	yourself).

package setPrerequisites: (IdentitySet new
	add: '..\..\..\Metagnostic\CU Space Breakdown';
	add: '..\..\..\Object Arts\Dolphin\Base\Dolphin';
	add: '..\..\..\Object Arts\Dolphin\MVP\Base\Dolphin MVP Base';
	add: '..\..\..\Object Arts\Dolphin\MVP\Models\Tree\Dolphin Tree Models';
	add: '..\..\..\Object Arts\Dolphin\MVP\Type Converters\Dolphin Type Converters';
	add: '..\..\..\Object Arts\Dolphin\MVP\Models\Value\Dolphin Value Models';
	add: '..\US Treemap - Base';
	add: '..\Layout\US Treemap - Layout Ordered';
	add: '..\Render\US Treemap - Render Cushion DirectToMemory';
	add: '..\Render\US Treemap - Render Flat';
	add: '..\US Treemap - View';
	yourself).

package!

"Class Definitions"!

ReferenceBreakdown subclass: #TreemapReferenceBreakdown
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
SpaceBreakdown subclass: #TreemapSpaceBreakdown
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!

"Global Aliases"!


"Loose Methods"!

"End of package definition"!

"Source Globals"!

"Classes"!

TreemapReferenceBreakdown guid: (GUID fromString: '{EC6B64B3-CFE6-49CB-A6EA-AE677ADF56CA}')!
TreemapReferenceBreakdown comment: ''!
!TreemapReferenceBreakdown categoriesForClass!Unclassified! !
!TreemapReferenceBreakdown methodsFor!

updateMainList
	"private -- rebuild the main list from our underlying data.
	Changes by Udo Schneider
	Assume a single selection list here instead of a multi selection list"

	| presenter selection list |
	presenter := self mainListPresenter.
	list := self filteredList.
selection := presenter selectionOrNil.

	presenter
		list: list.
	(list identityIncludes: selection) ifTrue: [presenter 
		selection: selection].
	presenter view autoResizeColumns.
	self updateTotals! !
!TreemapReferenceBreakdown categoriesFor: #updateMainList!private!updating! !

TreemapSpaceBreakdown guid: (GUID fromString: '{275E3FEC-B125-4DBC-945F-1CC3E18C64B7}')!
TreemapSpaceBreakdown comment: ''!
!TreemapSpaceBreakdown categoriesForClass!Unclassified! !
!TreemapSpaceBreakdown methodsFor!

breakdownClassReferences
	"command -- open a class breakdown of the currently selected classes' references"

	self canBreakdownClassReferences ifFalse: [^self].
	(TreemapReferenceBreakdown classes: self selectedClasses) refresh!

selectedClasses
	"private -- answer the currently selected classes, a possibly
	empty collection"
^self mainListPresenter hasSelection ifTrue: [
Array with: self mainListPresenter selection subject] ifFalse: [#()]	!

updateMainList
	"private -- rebuild the main list from our underlying data.
	Changes by Udo Schneider
	Assume a single selection list here instead of a multi selection list"

	| presenter selection list |
	presenter := self mainListPresenter.
	list := self filteredList.
selection := presenter selectionOrNil.

	presenter
		list: list.
	(list identityIncludes: selection) ifTrue: [presenter 
		selection: selection].
	presenter view autoResizeColumns.
	self updateTotals! !
!TreemapSpaceBreakdown categoriesFor: #breakdownClassReferences!commands!public! !
!TreemapSpaceBreakdown categoriesFor: #selectedClasses!accessing!private! !
!TreemapSpaceBreakdown categoriesFor: #updateMainList!private!updating! !

"Binary Globals"!

"Resources"!

(ResourceIdentifier class: TreemapReferenceBreakdown name: 'Default view') assign: (Object fromBinaryStoreBytes:
(ByteArray fromBase64String: 'IVNUQiAxIEYCDAABAAAAVmlld1Jlc291cmNlAAAAAA4BJABTVEJSZXNvdXJjZVNUQkJ5dGVBcnJh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'))!

(ResourceIdentifier class: TreemapSpaceBreakdown name: 'Default view') assign: (Object fromBinaryStoreBytes:
(ByteArray fromBase64String: 'IVNUQiAxIEYCDAABAAAAVmlld1Jlc291cmNlAAAAAA4BJABTVEJSZXNvdXJjZVNUQkJ5dGVBcnJh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'))!

(ResourceIdentifier class: TreemapSpaceBreakdown name: 'Read-only view') assign: (Object fromBinaryStoreBytes:
(ByteArray fromBase64String: 'IVNUQiAxIEYCDAABAAAAVmlld1Jlc291cmNlAAAAAA4BJABTVEJSZXNvdXJjZVNUQkJ5dGVBcnJh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'))!

