| package |
package := Package name: 'US Treemap - Development'.
package paxVersion: 0;
	basicComment: ''.

package basicPackageVersion: '0.010'.


package classNames
	add: #NonRenderStrategy;
	yourself.

package methodNames
	add: 'TreeMapModel class' -> #publishedAspectsOfInstances;
	add: 'TreeMapNode class' -> #publishedAspectsOfInstances;
	add: 'TreeMapRenderer class' -> #publishedAspectsOfInstances;
	add: 'TreeMapView class' -> #publishedAspectsOfInstances;
	yourself.

package binaryGlobalNames: (Set new
	yourself).

package globalAliases: (Set new
	yourself).

package allResourceNames: (Set new
	yourself).

package setPrerequisites: (IdentitySet new
	add: '..\..\Object Arts\Dolphin\IDE\Base\Development System';
	add: 'US Treemap - Base';
	add: 'Render\US Treemap - Render Abstract';
	add: 'US Treemap - View';
	yourself).

package!

"Class Definitions"!

AbstractTreeMapRenderStrategy subclass: #NonRenderStrategy
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!

"Global Aliases"!


"Loose Methods"!

!TreeMapModel class methodsFor!

publishedAspectsOfInstances
	| aspects |
	aspects := super publishedAspectsOfInstances.
	aspects
		add: (Aspect block: #sizeBlock);
		add: (Aspect block: #getNodeColorBlock).
	^aspects! !
!TreeMapModel class categoriesFor: #publishedAspectsOfInstances!must strip!public! !

!TreeMapNode class methodsFor!

publishedAspectsOfInstances
	"Answer a <LookupTable> of the <Aspect>s published by instances of the receiver."

	| aspects |
	aspects := super publishedAspectsOfInstances.
	aspects
		add: (Aspect number: #size);
		add: (Aspect name: #layoutRectangle);
		add: (Aspect collection: #children).
	^aspects! !
!TreeMapNode class categoriesFor: #publishedAspectsOfInstances!must strip!public! !

!TreeMapRenderer class methodsFor!

publishedAspectsOfInstances
	"Answer a <LookupTable> of the <Aspect>s published by instances of the receiver."

	^(super publishedAspectsOfInstances)
	add: (Aspect name: #layoutStrategy chooseFrom: (self availableLayoutStrategies collect: [:each | each name , ' new']) ) beImmutable;
		add: (Aspect name: #renderStrategy chooseFrom: (self availableRenderStrategies collect: [:each | each name , ' new']) ) beImmutable;
		add: (Aspect block: #nodeColorBlock);
		add: (Aspect block: #nodeSizeBlock);
		yourself
	! !
!TreeMapRenderer class categoriesFor: #publishedAspectsOfInstances!public! !

!TreeMapView class methodsFor!

publishedAspectsOfInstances
	"Answer a <LookupTable> of the <Aspect>s published by instances of the receiver."

	| aspects |
	aspects := super publishedAspectsOfInstances.
	aspects
		add: (Aspect name: #renderer);
		add: (Aspect block: #getImageBlock);
		add: (Aspect block: #getTextBlock).
	^aspects! !
!TreeMapView class categoriesFor: #publishedAspectsOfInstances!public! !

"End of package definition"!

"Source Globals"!

"Classes"!

NonRenderStrategy guid: (GUID fromString: '{80446A49-5BC8-4924-90E7-2132770C0B8D}')!
NonRenderStrategy comment: ''!
!NonRenderStrategy categoriesForClass!Unclassified! !
!NonRenderStrategy methodsFor!

render: node using: renderState 
	"Simply do nothing ;-)"! !
!NonRenderStrategy categoriesFor: #render:using:!public! !

"Binary Globals"!

"Resources"!

