| package |
package := Package name: 'US Treemap - View'.
package paxVersion: 0;
	basicComment: 'TreePresenter addView: TreeMapView asResource: ''Treemap view''.
TreePresenter addView: TreeMapView asResource: ''Treemap view asynchronous''.
ListPresenter addView: TreeMapView asResource: ''Treemap view''.
ListPresenter addView: TreeMapView asResource: ''Treemap view asynchronous''.'.

package basicPackageVersion: '0.065'.

package imageStripperBytes: (ByteArray fromBase64String: 'IVNUQiAxIEYPDQAEAAAASW1hZ2VTdHJpcHBlcgAAAAAAAAAAUgAAAA4AAABVUyBUcmVlTWFwVmll
d1IAAAAAAAAAmgAAAAAAAABSAAAAEAAAAERvbHBoaW4gTVZQIEJhc2VSAAAAFQAAAFJ1bnRpbWVT
ZXNzaW9uTWFuYWdlcu+/JQAAAAAABgMPAFZlcnNpb25SZXNvdXJjZQAAAAAGARAAVlNfRklYRURG
SUxFSU5GTwAAAAByAAAANAAAAL0E7/4AAAEAAAABAAEAAAAAAAEAAQAAAD8AAAAAAAAABAAAAAIA
AAAAAAAAAAAAAAAAAADqAAAAAAAAAPAAAABiAAAAAgAAAFIAAAAIAAAAMDQwOTA0YjDqAAAAAAAA
APAAAABiAAAAGAAAAFIAAAAOAAAAUHJvZHVjdFZlcnNpb25SAAAACgAAADEsIDAsIDAsIDFSAAAA
CwAAAENvbXBhbnlOYW1lUgAAAAAAAABSAAAADAAAAFByaXZhdGVCdWlsZFIAAAAAAAAAUgAAAAwA
AABTcGVjaWFsQnVpbGRSAAAAAAAAAFIAAAAPAAAARmlsZURlc2NyaXB0aW9uUgAAABsAAABEb2xw
aGluIFhQIFRvR28gQXBwbGljYXRpb25SAAAADwAAAExlZ2FsVHJhZGVtYXJrc1IAAAAxAAAARG9s
cGhpbiBpcyBhIHRyYWRlbWFyayBvZiBDR0kgR3JvdXAgKEV1cm9wZSkgTHRkLlIAAAAMAAAASW50
ZXJuYWxOYW1lUgAAAAAAAABSAAAAEAAAAE9yaWdpbmFsRmlsZW5hbWVSAAAAAAAAAFIAAAAOAAAA
TGVnYWxDb3B5cmlnaHRSAAAAKwAAAFBvcnRpb25zIENvcHlyaWdodCCpIE9iamVjdCBBcnRzIDE5
OTctMjAwMy5SAAAACAAAAENvbW1lbnRzUgAAABwAAABQb3dlcmVkIGJ5IERvbHBoaW4gU21hbGx0
YWxrUgAAAAsAAABGaWxlVmVyc2lvblIAAAAKAAAAMSwgMCwgMCwgMVIAAAALAAAAUHJvZHVjdE5h
bWVSAAAAHQAAAEEgRG9scGhpbiBYUCBUb0dvIEFwcGxpY2F0aW9uygAAAAAAAADQAAAAYgAAAAEA
AAAGAgoARFdPUkRBcnJheQAAAAByAAAABAAAAAkEsAQDAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
AAAAAAAAAAAAAAA=').

package classNames
	add: #AsynchronousTreeMapView;
	add: #TreeMapView;
	yourself.

package methodNames
	add: #Color -> #negative;
	add: 'Brush class' -> #hatchedDiagonalCross;
	yourself.

package resourceNames
	add: #ListPresenter -> 'Treemap view';
	add: #ListPresenter -> 'Treemap view asynchronous';
	add: #TreePresenter -> 'Treemap view';
	add: #TreePresenter -> 'Treemap view asynchronous';
	yourself.

package binaryGlobalNames: (Set new
	yourself).

package globalAliases: (Set new
	yourself).

package allResourceNames: (Set new
	add: #ListPresenter -> 'Treemap view';
	add: #ListPresenter -> 'Treemap view asynchronous';
	add: #TreePresenter -> 'Treemap view';
	add: #TreePresenter -> 'Treemap view asynchronous';
	yourself).

package setPrerequisites: (IdentitySet new
	add: '..\..\Object Arts\Dolphin\Base\Dolphin';
	add: '..\..\Object Arts\Dolphin\MVP\Base\Dolphin MVP Base';
	add: '..\..\Object Arts\Dolphin\MVP\Models\Tree\Dolphin Tree Models';
	add: '..\..\Object Arts\Dolphin\Lagoon\Lagoon Image Stripper';
	add: '..\US Tooltips';
	add: 'US Treemap - Base';
	add: 'Layout\US Treemap - Layout Slice and Dice';
	add: 'Render\US Treemap - Render Flat';
	yourself).

package!

"Class Definitions"!

View subclass: #TreeMapView
	instanceVariableNames: 'treeMapModel renderer dib needsUpdate selection getTextBlock getImageBlock tooltip tooltipRectangle'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
TreeMapView subclass: #AsynchronousTreeMapView
	instanceVariableNames: 'renderProcess renderText'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!

"Global Aliases"!


"Loose Methods"!

!Brush class methodsFor!

hatchedDiagonalCross
	"Answer a diagonal crosshatched instance of the receiver"

	^self 
		withStyle: BS_HATCHED
		color: 0
		hatch: HS_DIAGCROSS
! !
!Brush class categoriesFor: #hatchedDiagonalCross!public! !

!Color methodsFor!

negative
	"Return the color's negative"
	| temp |
	temp := self asRGB.
	^Color 
		red: 255 - temp red
		green: 255 - temp green
		blue: 255 - temp blue! !
!Color categoriesFor: #negative!converting!public! !

"End of package definition"!

"Source Globals"!

"Classes"!

TreeMapView guid: (GUID fromString: '{FD92BE49-1F90-4073-8191-BBE2DBA17062}')!
TreeMapView comment: ''!
!TreeMapView categoriesForClass!Unclassified! !
!TreeMapView methodsFor!

autoResizeColumns
"Do nothing"!

basicSelection: aTreeMapNode cause: aSymbol 
	"Private - Set the selection to the <TreeMapNode> argument 
	and update the view. Answer the new selection."

	selection == aTreeMapNode 
		ifFalse: 
			[(aSymbol == #unknown or: [self onSelChanging: aTreeMapNode cause: aSymbol]) 
				ifTrue: 
					[| oldSelection |
					oldSelection := self selectedNode.
					oldSelection notNil 
						ifTrue: [self invalidateRect: (oldSelection layoutRectangle truncated ) erase: true].
					selection := aTreeMapNode == treeMapModel rootNode ifFalse: [aTreeMapNode].

					"ensure new selection is visible - might need to expand the tree"
					selection notNil 
						ifTrue: 
							[| rectangle |
					
							rectangle := selection layoutRectangle .
							self invalidateRect: rectangle truncated erase: false.
							self ensureRectangleVisible: rectangle truncated].
					self onSelChanged]].
	^selection!

connectModel
	"Connect the receiver to its model, wiring events, etc."

	(self model)
		when: #treeChanged:
			send: #settingsChanged
			to: self;
		when: #item:addedInParent:
			send: #settingsChanged
			to: self;
		when: #item:removedFromParent:
			send: #settingsChanged
			to: self;
		when: #item:movedToParent:
			send: #settingsChanged
			to: self;
		when: #itemUpdated:
			send: #settingsChanged
			to: self;
		when: #listChanged
			send: #settingsChanged
			to: self!

createDib
	dib := DIBSection 
				width: View desktop clientRectangle width
				height: View desktop  clientRectangle height
				depth: 32!

defaultBackColor
		^Color black!

defaultFont
^(Font name: 'Arial' pointSize: 16)!

defaultGetImageBlock
	"Private - Answer a <monadicValuable>, or nil, to use to find out the image index of an object 
	that will be placed in the receiver. Nil is treated as implying the column has no associated images.
	Implementation Note: Answer nil as by default we do not have per-column images."

	^nil!

defaultGetTextBlock
	"Private - Answer a default block to use to find out the children of an object
	that will be placed in the receiver."

	^BasicListAbstract!

dib
	dib isNil ifTrue: [ self createDib].^dib!

errorNoSelection
	"Private - Raise an error to the effect that there is no selection."

	^self error: 'No object selected'!

findNodeForObject: anObject 
	"Private - Answer the first node in the receiver located using a pre-order traversal from the roots,
	for which the receiver's model's search policy evaluates to true for the <Object> argument..
	If there is no matching node then answer nil. Note that no check is made to verify that the object 
	is actually part of the model."

	"We shouldn't have to special case nil since the anchorNode is associated with that in the tree, but
	 since the search policy might be user supplied it might not consider nil as comparing equal to nil"

	^anObject isNil 
		ifTrue: [treeMapModel rootNode]
		ifFalse: 
			[treeMapModel isNil ifFalse: [treeMapModel nodeForObject: anObject] ifTrue: [nil]]!

getImageBlock
	^nil!

getImageBlock: aBlock 
	!

getTextBlock
^getTextBlock !

getTextBlock: aBlock 
	getTextBlock := aBlock!

hasSelection
	"Answer true if the receiver has a selection."

	^self selectedNode notNil!

hideTooltip

tooltipRectangle := nil.
				self tooltip pop.!

hitTest: position 
	^treeMapModel leafNodeAt: position!

initialize
	super initialize.
	needsUpdate := true.
	self backcolor: self defaultBackColor.
	self font: self defaultFont.
	self renderer: TreeMapRenderer new.
self getImageBlock: self defaultGetImageBlock.
	self getTextBlock: self defaultGetTextBlock!

nodeForObject: anObject ifAbsent: exceptionHandler 
	"Private - Answer the first node in the receiver located using a pre-order traversal from the roots,
	for which the receiver's model's search policy evaluates to true for the <Object>, comperand.
	If there is no matching node, then expand the parent chain and try again."

	| node |
	node := self findNodeForObject: anObject.

			node isNil ifTrue: [exceptionHandler value].
	^node!

onButtonDown: aMouseEvent
	"Private - Handle a mouse click from left or right mouse buttons."

	self setFocus.
	(self hitTest: aMouseEvent position) 
		ifNil: [aMouseEvent isRButtonDown ifTrue: [self basicSelection: nil cause: #mouse]]
		ifNotNil: 
			[:node | 
		
			
				node == self selectedNode 
						ifFalse: 
							[self basicSelection: node cause: #mouse.
							"The selection change may have been refused."
							self selectedNode == node ifFalse: [^self]].
					self isDragSource ifTrue: [self onBegin: aMouseEvent button drag: node object]]!

onLeftButtonPressed: aMouseEvent
	"Change the selection on left mouse button. This may also start a drag operation."

	self onButtonDown: aMouseEvent.
	^super onLeftButtonPressed: aMouseEvent!

onModelChanged
	super onModelChanged.
	treeMapModel := selection := nil.
	needsUpdate := true.
	self invalidate!

onMouseMoved: aMouseEvent 
	(tooltipRectangle notNil 
		and: [(tooltipRectangle containsPoint: aMouseEvent position) not]) 
			ifTrue: 
				[self hideTooltip]!

onPaintRequired: aPaintEvent 
	| canvas |
	canvas := aPaintEvent canvas.
	needsUpdate ifTrue: [self updateCachedBitmap].
	self
		renderAllOn: canvas!

onPositionChanged: aPositionEvent 
	needsUpdate := true.
	self  invalidate.
	^super onPositionChanged: aPositionEvent!

onRightButtonPressed: aMouseEvent
	"Change the selection on right mouse button and pop the context menu.
	This may also start a right drag operation."

	self onButtonDown: aMouseEvent.
	^super onRightButtonPressed: aMouseEvent!

onSelChanged
	"Private - Handle a selection change event"

	
			self presenter onSelectionChanged!

onSelChanging: aTreeMapNode cause: aSymbol 
	"Private - Selection is changing in the receiver to the specified <TreeMapNode> as a
	direct result of user input. The user input type is #keyboard or #mouse, as determined 
	by the <Symbol> argument. A #selectionChanging: event is triggered to enquire as to 
	whether the selection change is permissible. If it is not then any observer that wishes to 
	veto the change must set the the value of the <SelectionChangingEvent> to false. Note 
	that selection notifications are not propagated during state restoral."

	^self isStateRestoring or: 
			[| event |
			event := SelectionChangingEvent forSource: self.
			event cause: aSymbol.
			aTreeMapNode notNil ifTrue: [event newSelection: aTreeMapNode object].
			selection notNil ifTrue: [event oldSelection: selection object].
			self presenter onSelectionChanging: event.
			event value]!

onSelectionChanged
	"Sent by #onSelChange when the receiver.
	The default is to trigger an #selectionChanged event of the presenter"

	self presenter trigger: #selectionChanged.
	self invalidateUserInterface.!

onSelectionChanging: aSelectionChangingEvent
	"Handler to indicate that the receiver's selection is about to change.
	To prevent the proposed change under cdertain circumstances a handler
	can set the value of aValueHolder to false.
	The default is to trigger an #selectionChanging: event off the presenter"

	self presenter trigger: #selectionChanging: with: aSelectionChangingEvent!

onViewOpened
	renderer 
		when: #renderSettingsChanged
		send: #settingsChanged
		to: self.
	self tooltip addTool: self.
	super onViewOpened!

renderAllOn: aCanvas
	self
		renderTreemapOn: aCanvas;
		renderSelectionOn: aCanvas!

renderer
	^renderer!

renderer: aTreeMapRenderer 
	renderer := aTreeMapRenderer.
!

renderSelectionOn: aCanvas 
	self hasSelection 
		ifTrue: 
			[| selectionDib dibRectangle |
			dibRectangle := 0 @ 0 extent: selection layoutRectangle truncated width 
								@ selection layoutRectangle truncated height.
			selectionDib := DIBSection width: dibRectangle width height: dibRectangle height.
			selectionDib canvas fillRectangle: dibRectangle brush: Brush hatchedDiagonalCross.
			aCanvas 
				bitBlt: selectionDib canvas
				rectangle: dibRectangle
				to: selection layoutRectangle truncated topLeft
				rop: 16r8800C6.
			aCanvas invertRectangle: selection layoutRectangle truncated]!

renderStrategy
	^renderer renderStrategy!

renderStrategy: anObject 
renderer renderStrategy: anObject !

renderTreemapOn: canvas 
	self dib drawOn: canvas!

resetSelection
	"Set the receiver to have no selection."

	self basicSelection: nil cause: #unknown!

selectedNode
	"Private - Answer the selected node or nil if no selection."


	^selection!

selection
	"Answer a single selected object. 
	Raise an error if no objects are selected."

	^self selectionIfNone: [self errorNoSelection]
!

selection: newSelection
	"Select the first occurence of the <Object>, newSelection, in the receiver. 
	If not present then signal a NotFoundError.
	Answer anObject"

	^self selection: newSelection ifAbsent: [self errorNotFound: newSelection]!

selection: anObject ifAbsent: exceptionHandler
	"Select the first occurence of anObject in the receiver
	and answer anObject, or if there are no occurrences, the 
	result of evaluating the <niladicValuable>, exceptionHandler."

	| node |
	anObject isNil ifTrue: [^self resetSelection].
	node := self nodeForObject: anObject ifAbsent: [^exceptionHandler value].
	self basicSelection: node cause: #unknown.
	^anObject!

selectionIfNone: aBlock
	"Answer the selected object or the result of evaluating aBlock
	if there is no selection."

	| selNode |
	^(selNode := self selectedNode) isNil
		ifTrue: [aBlock value]
		ifFalse: [selNode object]!

selectionOrNil
	"Return the selected object or nil if no selection."

	^self selectionIfNone: []!

selectionOrNil: newSelection
	"Select the first occurence of the <Object>, newSelection, in the
	receiver. If newSelection is nil, then simply remove the existing
	selection. If newSelection is not present then signal a NotFoundError.
	Answer newSelection."

	newSelection isNil 
		ifTrue: [self resetSelection]
		ifFalse: [self selection: newSelection].
	^newSelection!

settingsChanged
	needsUpdate := true.
self hideTooltip.
	self invalidate!

tooltip

	tooltip isNil ifTrue: [tooltip := Tooltip new].
	^tooltip!

toolTipText
^treeMapModel  notNil ifTrue: [

	| node |
	node := treeMapModel leafNodeAt: self cursorPosition.
	node notNil 
		ifTrue: 
			[tooltipRectangle := node layoutRectangle.
			getTextBlock value: node object]
		ifFalse: 
			[tooltipRectangle := nil.
			'']

] ifFalse: ['']
	!

updateCachedBitmap
	| object |
	needsUpdate := false.
	selection notNil ifTrue: [object := selection object].
	selection := treeMapModel := nil.
	renderer
		setModel: self model;
		setLayoutRectangle: self clientRectangle;
		setBitmap: self dib;
		render.
	treeMapModel := renderer treeMapModel.
	object notNil ifTrue: [self selection: object].
	self invalidate! !
!TreeMapView categoriesFor: #autoResizeColumns!public! !
!TreeMapView categoriesFor: #basicSelection:cause:!private!selection! !
!TreeMapView categoriesFor: #connectModel!public! !
!TreeMapView categoriesFor: #createDib!initialize/release!public! !
!TreeMapView categoriesFor: #defaultBackColor!public! !
!TreeMapView categoriesFor: #defaultFont!public! !
!TreeMapView categoriesFor: #defaultGetImageBlock!adapters!constants!private! !
!TreeMapView categoriesFor: #defaultGetTextBlock!adapters!constants!private! !
!TreeMapView categoriesFor: #dib!initialize/release!public! !
!TreeMapView categoriesFor: #errorNoSelection!exceptions!private! !
!TreeMapView categoriesFor: #findNodeForObject:!private!searching! !
!TreeMapView categoriesFor: #getImageBlock!public! !
!TreeMapView categoriesFor: #getImageBlock:!public! !
!TreeMapView categoriesFor: #getTextBlock!public! !
!TreeMapView categoriesFor: #getTextBlock:!public! !
!TreeMapView categoriesFor: #hasSelection!public!testing! !
!TreeMapView categoriesFor: #hideTooltip!event handling!private! !
!TreeMapView categoriesFor: #hitTest:!helpers!private! !
!TreeMapView categoriesFor: #initialize!initialize/release!public! !
!TreeMapView categoriesFor: #nodeForObject:ifAbsent:!private!searching! !
!TreeMapView categoriesFor: #onButtonDown:!event handling!private! !
!TreeMapView categoriesFor: #onLeftButtonPressed:!event handling!public! !
!TreeMapView categoriesFor: #onModelChanged!event handling!public! !
!TreeMapView categoriesFor: #onMouseMoved:!event handling!public! !
!TreeMapView categoriesFor: #onPaintRequired:!event handling!public! !
!TreeMapView categoriesFor: #onPositionChanged:!event handling!public! !
!TreeMapView categoriesFor: #onRightButtonPressed:!event handling!public! !
!TreeMapView categoriesFor: #onSelChanged!event handling!private! !
!TreeMapView categoriesFor: #onSelChanging:cause:!event handling!private! !
!TreeMapView categoriesFor: #onSelectionChanged!event handling!public! !
!TreeMapView categoriesFor: #onSelectionChanging:!event handling!public! !
!TreeMapView categoriesFor: #onViewOpened!initialize/release!public! !
!TreeMapView categoriesFor: #renderAllOn:!public!rendering! !
!TreeMapView categoriesFor: #renderer!accessing!private! !
!TreeMapView categoriesFor: #renderer:!accessing!private! !
!TreeMapView categoriesFor: #renderSelectionOn:!public! !
!TreeMapView categoriesFor: #renderStrategy!accessing!public! !
!TreeMapView categoriesFor: #renderStrategy:!accessing!public! !
!TreeMapView categoriesFor: #renderTreemapOn:!public!rendering! !
!TreeMapView categoriesFor: #resetSelection!public!selection! !
!TreeMapView categoriesFor: #selectedNode!private!selection! !
!TreeMapView categoriesFor: #selection!public!selection! !
!TreeMapView categoriesFor: #selection:!public!selection! !
!TreeMapView categoriesFor: #selection:ifAbsent:!public!selection! !
!TreeMapView categoriesFor: #selectionIfNone:!public!selection! !
!TreeMapView categoriesFor: #selectionOrNil!public!selection! !
!TreeMapView categoriesFor: #selectionOrNil:!public!selection! !
!TreeMapView categoriesFor: #settingsChanged!accessing!public! !
!TreeMapView categoriesFor: #tooltip!initialize/release!public! !
!TreeMapView categoriesFor: #toolTipText!public! !
!TreeMapView categoriesFor: #updateCachedBitmap!public!updating! !

!TreeMapView class methodsFor!

defaultModel
	^TreeModel new!

icon
	^Icon fromId: 'resources\treemap.ico' ! !
!TreeMapView class categoriesFor: #defaultModel!public! !
!TreeMapView class categoriesFor: #icon!public! !

AsynchronousTreeMapView guid: (GUID fromString: '{A853B97E-2FF4-43E2-B63C-DB10E8003DA1}')!
AsynchronousTreeMapView comment: ''!
!AsynchronousTreeMapView categoriesForClass!Unclassified! !
!AsynchronousTreeMapView methodsFor!

defaultRenderText
^'Rendering TreeMap'!

onPaintRequired: aPaintEvent 
	| canvas |
	canvas := aPaintEvent canvas.
	needsUpdate 
		ifTrue: 
			[self startRenderProccess].
	(renderProcess notNil and: [renderProcess isTerminated]) 
		ifTrue: [self renderAllOn: canvas]
		ifFalse: [self renderInProgressOn: canvas]!

onViewClosed
	renderProcess notNil 
				ifTrue: [renderProcess isTerminated ifFalse: [renderProcess terminate]. ].super onViewClosed

	!

renderInProgressOn: canvas 
	canvas
		brush: (Brush color: self backcolor);
		fillRectangle: self clientRectangle;
		font: self font;
		setTextAlign: TA_CENTER | TA_BASELINE;
		setBkMode: TRANSPARENT;
		setTextColor: self backcolor negative;
		text: self text at: self clientRectangle center!

startRenderProccess
renderProcess notNil 
				ifTrue: [renderProcess isTerminated ifFalse: [renderProcess terminate]].
			renderProcess := [self updateCachedBitmap] forkAt: Processor systemBackgroundPriority.
			renderProcess name: 'TreeMap Renderer'!

text
renderText isNil ifTrue: [ renderText := self defaultRenderText].^renderText!

text: aString 
	renderText := aString! !
!AsynchronousTreeMapView categoriesFor: #defaultRenderText!public!rendering! !
!AsynchronousTreeMapView categoriesFor: #onPaintRequired:!event handling!public! !
!AsynchronousTreeMapView categoriesFor: #onViewClosed!event handling!public! !
!AsynchronousTreeMapView categoriesFor: #renderInProgressOn:!public!rendering! !
!AsynchronousTreeMapView categoriesFor: #startRenderProccess!event handling!public! !
!AsynchronousTreeMapView categoriesFor: #text!public!rendering! !
!AsynchronousTreeMapView categoriesFor: #text:!public!rendering! !

"Binary Globals"!

"Resources"!

(ResourceIdentifier class: ListPresenter name: 'Treemap view') assign: (Object fromBinaryStoreBytes:
(ByteArray fromBase64String: 'IVNUQiAxIEYCDAABAAAAVmlld1Jlc291cmNlAAAAAA4BJABTVEJSZXNvdXJjZVNUQkJ5dGVBcnJh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'))!

(ResourceIdentifier class: ListPresenter name: 'Treemap view asynchronous') assign: (Object fromBinaryStoreBytes:
(ByteArray fromBase64String: 'IVNUQiAxIEYCDAABAAAAVmlld1Jlc291cmNlAAAAAA4BJABTVEJSZXNvdXJjZVNUQkJ5dGVBcnJh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'))!

(ResourceIdentifier class: TreePresenter name: 'Treemap view') assign: (Object fromBinaryStoreBytes:
(ByteArray fromBase64String: 'IVNUQiAxIEYCDAABAAAAVmlld1Jlc291cmNlAAAAAA4BJABTVEJSZXNvdXJjZVNUQkJ5dGVBcnJh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'))!

(ResourceIdentifier class: TreePresenter name: 'Treemap view asynchronous') assign: (Object fromBinaryStoreBytes:
(ByteArray fromBase64String: 'IVNUQiAxIEYCDAABAAAAVmlld1Jlc291cmNlAAAAAA4BJABTVEJSZXNvdXJjZVNUQkJ5dGVBcnJh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'))!

