| package |
package := Package name: 'US Metafile'.
package paxVersion: 0;
	basicComment: ''.


package classNames
	add: #MetafileCanvas;
	yourself.

package methodNames
	add: #GDILibrary -> #closeMetaFile:;
	add: #GDILibrary -> #createMetaFile:;
	yourself.

package binaryGlobalNames: (Set new
	yourself).

package globalAliases: (Set new
	yourself).

package allResourceNames: (Set new
	yourself).

package setPrerequisites: (IdentitySet new
	add: '..\Object Arts\Dolphin\MVP\Base\Dolphin MVP Base';
	yourself).

package!

"Class Definitions"!

Canvas subclass: #MetafileCanvas
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!

"Global Aliases"!


"Loose Methods"!

!GDILibrary methodsFor!

closeMetaFile: hdc 
	"Closes a metafile device context and returns a handle that identifies a Windows-format metafile
		HMETAFILE CloseMetaFile(
			HDC hdc   // handle to Windows-metafile DC
		);"

	<stdcall: handle CloseMetaFile handle>
	^self invalidCall!

createMetaFile: lpszFile
	"Creates a device context for a Windows-format metafile.
		HDC CreateMetaFile(
			LPCTSTR lpszFile   // file name
		);"
<stdcall: handle CreateMetaFile lpstr>
^self invalidCall


! !
!GDILibrary categoriesFor: #closeMetaFile:!public!win32 functions-device context! !
!GDILibrary categoriesFor: #createMetaFile:!public!win32 functions-device context! !

"End of package definition"!

"Source Globals"!

"Classes"!

MetafileCanvas guid: (GUID fromString: '{1FBA093D-24AA-4B20-997D-1AF6506F151E}')!
MetafileCanvas comment: ''!
!MetafileCanvas categoriesForClass!Graphics-Drawing! !
!MetafileCanvas methodsFor!

basicFree
	"Private - Free the external resources associated with the receiver."

	super basicFree
.

	GDILibrary current closeMetaFile: self asParameter.! !
!MetafileCanvas categoriesFor: #basicFree!private!realizing/unrealizing! !

!MetafileCanvas class methodsFor!

onFile: aFilename

|hDC|
	^(hDC := GDILibrary current createMetaFile: aFilename) isNil ifFalse: [self withOwnedDC: hDC]
! !
!MetafileCanvas class categoriesFor: #onFile:!public! !

"Binary Globals"!

"Resources"!

